From 631ac99a6f14dddc21faa14cb9067c7aec7f67ec Mon Sep 17 00:00:00 2001
From: Dan Walsh <dwalsh@redhat.com>
Date: Fri, 11 Oct 2013 10:16:57 -0400
Subject: [PATCH 65/74] These are massive changes involved in building new GUI.

Too difficult to break out into seperate patches at this point.
Since almost no other groups are using sepolicy yet, I will push together.
---
 policycoreutils/sepolicy/.gitignore                |    2 +
 policycoreutils/sepolicy/Makefile                  |   18 +-
 policycoreutils/sepolicy/org.selinux.conf          |   23 +
 policycoreutils/sepolicy/org.selinux.policy        |   80 +
 policycoreutils/sepolicy/org.selinux.service       |    4 +
 policycoreutils/sepolicy/selinux_client.py         |   43 +
 policycoreutils/sepolicy/selinux_server.py         |  131 +
 policycoreutils/sepolicy/sepolgen.8                |    1 +
 .../sepolicy/sepolicy-bash-completion.sh           |   24 +-
 policycoreutils/sepolicy/sepolicy-generate.8       |   71 +-
 policycoreutils/sepolicy/sepolicy-gui.8            |   29 +
 policycoreutils/sepolicy/sepolicy-interface.8      |   11 +-
 policycoreutils/sepolicy/sepolicy-manpage.8        |    5 +-
 policycoreutils/sepolicy/sepolicy-network.8        |   58 +-
 policycoreutils/sepolicy/sepolicy.8                |    6 +-
 policycoreutils/sepolicy/sepolicy.desktop          |   10 +
 policycoreutils/sepolicy/sepolicy.py               |  397 +-
 policycoreutils/sepolicy/sepolicy/__init__.py      |  866 ++-
 policycoreutils/sepolicy/sepolicy/communicate.py   |    2 +-
 policycoreutils/sepolicy/sepolicy/generate.py      |  127 +-
 policycoreutils/sepolicy/sepolicy/gui.py           | 2833 ++++++++++
 policycoreutils/sepolicy/sepolicy/help/__init__.py |    0
 .../sepolicy/sepolicy/help/booleans.png            |  Bin 0 -> 72749 bytes
 .../sepolicy/sepolicy/help/booleans.txt            |    7 +
 .../sepolicy/sepolicy/help/booleans_more.png       |  Bin 0 -> 62348 bytes
 .../sepolicy/sepolicy/help/booleans_more.txt       |    5 +
 .../sepolicy/sepolicy/help/booleans_more_show.png  |  Bin 0 -> 34948 bytes
 .../sepolicy/sepolicy/help/booleans_more_show.txt  |    4 +
 .../sepolicy/sepolicy/help/booleans_toggled.png    |  Bin 0 -> 61958 bytes
 .../sepolicy/sepolicy/help/booleans_toggled.txt    |    5 +
 .../sepolicy/sepolicy/help/file_equiv.png          |  Bin 0 -> 49221 bytes
 .../sepolicy/sepolicy/help/file_equiv.txt          |   21 +
 .../sepolicy/sepolicy/help/files_apps.png          |  Bin 0 -> 81978 bytes
 .../sepolicy/sepolicy/help/files_apps.txt          |   10 +
 .../sepolicy/sepolicy/help/files_exec.png          |  Bin 0 -> 67866 bytes
 .../sepolicy/sepolicy/help/files_exec.txt          |    5 +
 .../sepolicy/sepolicy/help/files_write.png         |  Bin 0 -> 77773 bytes
 .../sepolicy/sepolicy/help/files_write.txt         |   11 +
 .../sepolicy/sepolicy/help/lockdown.png            |  Bin 0 -> 50599 bytes
 .../sepolicy/sepolicy/help/lockdown.txt            |    5 +
 .../sepolicy/sepolicy/help/lockdown_permissive.png |  Bin 0 -> 30025 bytes
 .../sepolicy/sepolicy/help/lockdown_permissive.txt |   11 +
 .../sepolicy/sepolicy/help/lockdown_ptrace.png     |  Bin 0 -> 29336 bytes
 .../sepolicy/sepolicy/help/lockdown_ptrace.txt     |   15 +
 .../sepolicy/sepolicy/help/lockdown_unconfined.png |  Bin 0 -> 27473 bytes
 .../sepolicy/sepolicy/help/lockdown_unconfined.txt |   11 +
 policycoreutils/sepolicy/sepolicy/help/login.png   |  Bin 0 -> 40102 bytes
 policycoreutils/sepolicy/sepolicy/help/login.txt   |   23 +
 .../sepolicy/sepolicy/help/login_default.png       |  Bin 0 -> 41680 bytes
 .../sepolicy/sepolicy/help/login_default.txt       |   10 +
 .../sepolicy/sepolicy/help/ports_inbound.png       |  Bin 0 -> 58994 bytes
 .../sepolicy/sepolicy/help/ports_inbound.txt       |    8 +
 .../sepolicy/sepolicy/help/ports_outbound.png      |  Bin 0 -> 52979 bytes
 .../sepolicy/sepolicy/help/ports_outbound.txt      |    8 +
 policycoreutils/sepolicy/sepolicy/help/start.png   |  Bin 0 -> 14128 bytes
 policycoreutils/sepolicy/sepolicy/help/start.txt   |    7 +
 policycoreutils/sepolicy/sepolicy/help/system.png  |  Bin 0 -> 50601 bytes
 policycoreutils/sepolicy/sepolicy/help/system.txt  |    2 +
 .../sepolicy/sepolicy/help/system_boot_mode.png    |  Bin 0 -> 52674 bytes
 .../sepolicy/sepolicy/help/system_boot_mode.txt    |   14 +
 .../sepolicy/sepolicy/help/system_current_mode.png |  Bin 0 -> 52641 bytes
 .../sepolicy/sepolicy/help/system_current_mode.txt |    8 +
 .../sepolicy/sepolicy/help/system_export.png       |  Bin 0 -> 53210 bytes
 .../sepolicy/sepolicy/help/system_export.txt       |    8 +
 .../sepolicy/sepolicy/help/system_policy_type.png  |  Bin 0 -> 54631 bytes
 .../sepolicy/sepolicy/help/system_policy_type.txt  |    6 +
 .../sepolicy/sepolicy/help/system_relabel.png      |  Bin 0 -> 52867 bytes
 .../sepolicy/sepolicy/help/system_relabel.txt      |   12 +
 .../sepolicy/sepolicy/help/transition_file.png     |  Bin 0 -> 69779 bytes
 .../sepolicy/sepolicy/help/transition_file.txt     |   16 +
 .../sepolicy/sepolicy/help/transition_from.png     |  Bin 0 -> 63231 bytes
 .../sepolicy/sepolicy/help/transition_from.txt     |   11 +
 .../sepolicy/help/transition_from_boolean.png      |  Bin 0 -> 67329 bytes
 .../sepolicy/help/transition_from_boolean.txt      |    9 +
 .../sepolicy/help/transition_from_boolean_1.png    |  Bin 0 -> 71717 bytes
 .../sepolicy/help/transition_from_boolean_1.txt    |    2 +
 .../sepolicy/help/transition_from_boolean_2.png    |  Bin 0 -> 32219 bytes
 .../sepolicy/help/transition_from_boolean_2.txt    |    5 +
 .../sepolicy/sepolicy/help/transition_to.png       |  Bin 0 -> 58909 bytes
 .../sepolicy/sepolicy/help/transition_to.txt       |   11 +
 policycoreutils/sepolicy/sepolicy/help/users.png   |  Bin 0 -> 57622 bytes
 policycoreutils/sepolicy/sepolicy/help/users.txt   |   21 +
 policycoreutils/sepolicy/sepolicy/interface.py     |  198 +-
 policycoreutils/sepolicy/sepolicy/manpage.py       |  283 +-
 policycoreutils/sepolicy/sepolicy/network.py       |   42 +-
 policycoreutils/sepolicy/sepolicy/sedbus.py        |   58 +
 policycoreutils/sepolicy/sepolicy/sepolicy.glade   | 5633 ++++++++++++++++++++
 .../sepolicy/sepolicy/templates/network.py         |    3 +
 .../sepolicy/sepolicy/templates/script.py          |   21 +-
 .../sepolicy/sepolicy/templates/spec.py            |    8 +-
 .../sepolicy/sepolicy/templates/test_module.py     |  119 +
 .../sepolicy/sepolicy/templates/unit_file.py       |    2 +-
 .../sepolicy/sepolicy/templates/user.py            |   14 +-
 policycoreutils/sepolicy/sepolicy/transition.py    |   23 +-
 policycoreutils/sepolicy/setup.py                  |    2 +-
 95 files changed, 10841 insertions(+), 597 deletions(-)
 create mode 100644 policycoreutils/sepolicy/org.selinux.conf
 create mode 100644 policycoreutils/sepolicy/org.selinux.policy
 create mode 100644 policycoreutils/sepolicy/org.selinux.service
 create mode 100644 policycoreutils/sepolicy/selinux_client.py
 create mode 100644 policycoreutils/sepolicy/selinux_server.py
 create mode 100644 policycoreutils/sepolicy/sepolgen.8
 create mode 100644 policycoreutils/sepolicy/sepolicy-gui.8
 create mode 100644 policycoreutils/sepolicy/sepolicy.desktop
 create mode 100644 policycoreutils/sepolicy/sepolicy/gui.py
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/__init__.py
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/booleans.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/booleans.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/booleans_more.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/booleans_more.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/booleans_more_show.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/booleans_more_show.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/booleans_toggled.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/booleans_toggled.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/file_equiv.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/file_equiv.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/files_apps.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/files_apps.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/files_exec.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/files_exec.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/files_write.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/files_write.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/lockdown.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/lockdown.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/lockdown_permissive.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/lockdown_permissive.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/lockdown_ptrace.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/lockdown_ptrace.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/lockdown_unconfined.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/lockdown_unconfined.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/login.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/login.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/login_default.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/login_default.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/ports_inbound.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/ports_inbound.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/ports_outbound.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/ports_outbound.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/start.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/start.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/system.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/system.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/system_boot_mode.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/system_boot_mode.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/system_current_mode.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/system_current_mode.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/system_export.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/system_export.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/system_policy_type.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/system_policy_type.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/system_relabel.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/system_relabel.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/transition_file.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/transition_file.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/transition_from.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/transition_from.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/transition_from_boolean.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/transition_from_boolean.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/transition_from_boolean_1.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/transition_from_boolean_1.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/transition_from_boolean_2.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/transition_from_boolean_2.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/transition_to.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/transition_to.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/users.png
 create mode 100644 policycoreutils/sepolicy/sepolicy/help/users.txt
 create mode 100644 policycoreutils/sepolicy/sepolicy/sedbus.py
 create mode 100644 policycoreutils/sepolicy/sepolicy/sepolicy.glade
 create mode 100644 policycoreutils/sepolicy/sepolicy/templates/test_module.py

diff --git a/policycoreutils/sepolicy/.gitignore b/policycoreutils/sepolicy/.gitignore
index 378eac2..3186c86 100644
--- a/policycoreutils/sepolicy/.gitignore
+++ b/policycoreutils/sepolicy/.gitignore
@@ -1 +1,3 @@
 build
+tmp
+*.bak
diff --git a/policycoreutils/sepolicy/Makefile b/policycoreutils/sepolicy/Makefile
index 71d661c..90e31dd 100644
--- a/policycoreutils/sepolicy/Makefile
+++ b/policycoreutils/sepolicy/Makefile
@@ -4,10 +4,11 @@ SYSCONFDIR ?= $(DESTDIR)/etc/sysconfig
 LIBDIR ?= $(PREFIX)/lib
 BINDIR ?= $(PREFIX)/bin
 SBINDIR ?= $(PREFIX)/sbin
+DATADIR ?= $(PREFIX)/share
 MANDIR ?= $(PREFIX)/share/man
 LOCALEDIR ?= /usr/share/locale
 PYTHON ?= /usr/bin/python
-BASHCOMPLETIONDIR ?= $(DESTDIR)/etc/bash_completion.d/
+BASHCOMPLETIONDIR ?= $(DESTDIR)/usr/share/bash-completion/completions
 SHAREDIR ?= $(PREFIX)/share/sandbox
 override CFLAGS = -I$(PREFIX)/include -DPACKAGE="policycoreutils" -Wall -Werror -Wextra -W  -DSHARED -shared
 
@@ -22,6 +23,9 @@ clean:
 	$(PYTHON) setup.py clean
 	-rm -rf build *~ \#* *pyc .#*
 
+sepolgen:
+	ln -sf sepolicy sepolgen
+
 test:
 	@python test_sepolicy.py -v
 
@@ -29,7 +33,17 @@ install:
 	$(PYTHON) setup.py install `test -n "$(DESTDIR)" && echo --root $(DESTDIR)`
 	[ -d $(BINDIR) ] || mkdir -p $(BINDIR)
 	install -m 755 sepolicy.py $(BINDIR)/sepolicy
+	(cd $(BINDIR); ln -sf sepolicy sepolgen)
 	-mkdir -p $(MANDIR)/man8
 	install -m 644 *.8 $(MANDIR)/man8
 	-mkdir -p $(BASHCOMPLETIONDIR)
-	install -m 644 $(BASHCOMPLETIONS) $(BASHCOMPLETIONDIR)
+	install -m 644 $(BASHCOMPLETIONS) $(BASHCOMPLETIONDIR)/sepolicy
+	-mkdir -p $(DESTDIR)/etc/dbus-1/system.d/
+	install -m 644 org.selinux.conf $(DESTDIR)/etc/dbus-1/system.d/
+	-mkdir -p $(DESTDIR)/usr/share/dbus-1/system-services
+	install -m 644 org.selinux.service $(DESTDIR)/usr/share/dbus-1/system-services
+	-mkdir -p $(DESTDIR)/usr/share/polkit-1/actions/
+	install -m 644 org.selinux.policy $(DESTDIR)/usr/share/polkit-1/actions/
+	-mkdir -p $(DESTDIR)/usr/share/system-config-selinux
+	install -m 755 selinux_server.py $(DESTDIR)/usr/share/system-config-selinux
+	install -m 644 *.desktop $(DATADIR)/system-config-selinux
diff --git a/policycoreutils/sepolicy/org.selinux.conf b/policycoreutils/sepolicy/org.selinux.conf
new file mode 100644
index 0000000..a350978
--- /dev/null
+++ b/policycoreutils/sepolicy/org.selinux.conf
@@ -0,0 +1,23 @@
+<?xml version="1.0" encoding="UTF-8"?> <!-- -*- XML -*- -->
+
+<!DOCTYPE busconfig PUBLIC
+ "-//freedesktop//DTD D-BUS Bus Configuration 1.0//EN"
+ "http://www.freedesktop.org/standards/dbus/1.0/busconfig.dtd">
+<busconfig>
+
+  <!-- Only root can own the service -->
+  <policy user="root">
+    <allow own="org.selinux"/>
+  </policy>
+
+  <!-- Allow anyone to invoke methods on the interfaces,
+       authorization is performed by PolicyKit -->
+  <policy at_console="true">
+    <allow send_destination="org.selinux"/>
+  </policy>
+  <policy context="default">
+    <allow send_destination="org.selinux"
+	   send_interface="org.freedesktop.DBus.Introspectable"/>
+  </policy>
+
+</busconfig>
diff --git a/policycoreutils/sepolicy/org.selinux.policy b/policycoreutils/sepolicy/org.selinux.policy
new file mode 100644
index 0000000..c0a730c
--- /dev/null
+++ b/policycoreutils/sepolicy/org.selinux.policy
@@ -0,0 +1,80 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE policyconfig PUBLIC
+"-//freedesktop//DTD PolicyKit Policy Configuration 1.0//EN"
+"http://www.freedesktop.org/standards/PolicyKit/1.0/policyconfig.dtd">
+<policyconfig>
+
+    <vendor>Red Hat Inc.</vendor>
+    <vendor_url>http://www.redhat.com</vendor_url>
+
+    <action id="org.selinux.restorecon">
+        <description>SELinux write access</description>
+        <message>System policy prevents restorecon access to SELinux</message>
+        <defaults>
+            <allow_any>auth_admin_keep</allow_any>
+            <allow_inactive>auth_admin_keep</allow_inactive>
+            <allow_active>auth_admin_keep</allow_active>
+        </defaults>
+    </action>
+    <action id="org.selinux.setenforce">
+        <description>SELinux write access</description>
+        <message>System policy prevents setenforce access to SELinux</message>
+        <defaults>
+            <allow_any>auth_admin_keep</allow_any>
+            <allow_inactive>auth_admin_keep</allow_inactive>
+            <allow_active>auth_admin_keep</allow_active>
+        </defaults>
+    </action>
+    <action id="org.selinux.semanage">
+        <description>SELinux write access</description>
+        <message>System policy prevents semanage access to SELinux</message>
+        <defaults>
+            <allow_any>auth_admin_keep</allow_any>
+            <allow_inactive>auth_admin_keep</allow_inactive>
+            <allow_active>auth_admin_keep</allow_active>
+        </defaults>
+    </action>
+    <action id="org.selinux.customized">
+        <description>SELinux Read access</description>
+        <message>System policy prevents read access to SELinux</message>
+        <defaults>
+	  <allow_any>yes</allow_any>
+	  <allow_inactive>yes</allow_inactive>
+	  <allow_active>yes</allow_active>
+        </defaults>
+    </action>
+    <action id="org.selinux.semodule_list">
+        <description>SELinux list modules access</description>
+        <message>System policy prevents read access to SELinux modules</message>
+        <defaults>
+	  <allow_any>yes</allow_any>
+	  <allow_inactive>yes</allow_inactive>
+	  <allow_active>yes</allow_active>
+        </defaults>
+    </action>
+    <action id="org.selinux.relabel_on_boot">
+        <description>SELinux write access</description>
+        <message>System policy prevents relabel_on_boot access to SELinux</message>
+        <defaults>
+            <allow_any>yes</allow_any>
+        </defaults>
+    </action>
+    <action id="org.selinux.change_default_policy">
+        <description>SELinux write access</description>
+        <message>System policy prevents change_default_policy access to SELinux</message>
+        <defaults>
+            <allow_any>auth_admin_keep</allow_any>
+            <allow_inactive>auth_admin_keep</allow_inactive>
+            <allow_active>auth_admin_keep</allow_active>
+        </defaults>
+    </action>
+    <action id="org.selinux.change_policy_type">
+        <description>SELinux write access</description>
+        <message>System policy prevents change_policy_type access to SELinux</message>
+        <defaults>
+            <allow_any>auth_admin_keep</allow_any>
+            <allow_inactive>auth_admin_keep</allow_inactive>
+            <allow_active>auth_admin_keep</allow_active>
+        </defaults>
+    </action>
+</policyconfig>
diff --git a/policycoreutils/sepolicy/org.selinux.service b/policycoreutils/sepolicy/org.selinux.service
new file mode 100644
index 0000000..3dd9545
--- /dev/null
+++ b/policycoreutils/sepolicy/org.selinux.service
@@ -0,0 +1,4 @@
+[D-BUS Service]
+Name=org.selinux
+Exec=/usr/share/system-config-selinux/selinux_server.py
+User=root
diff --git a/policycoreutils/sepolicy/selinux_client.py b/policycoreutils/sepolicy/selinux_client.py
new file mode 100644
index 0000000..9d9792c
--- /dev/null
+++ b/policycoreutils/sepolicy/selinux_client.py
@@ -0,0 +1,43 @@
+import dbus
+import dbus.service
+from sepolicy.sedbus import SELinuxDBus
+
+def convert_customization(buf):
+    cust_dict = {}
+    cust_dict["fcontext-equiv"] = {}
+    for i in buf.split("\n"):
+        rec = i.split()
+        if len(rec) == 0:
+            continue
+        if rec[1] == "-D":
+            continue
+        if rec[0] not in cust_dict:
+            cust_dict[rec[0]] = {}
+        if rec[0] == "boolean":
+            cust_dict["boolean"][rec[-1]] = { "active": rec[2] == "-1" }
+        if rec[0] == "login":
+            cust_dict["login"][rec[-1]] = { "seuser": rec[3], "range": rec[5] }
+        if rec[0] == "interface":
+            cust_dict["login"][rec[-1]] = { "type": rec[3] }
+        if rec[0] == "user":
+            cust_dict["user"][rec[-1]] = { "level": rec[3], "range": rec[5], "role": rec[7] }
+        if rec[0] == "port":
+            cust_dict["port"][(rec[-1], rec[-2] )] = { "type": rec[3] }
+        if rec[0] == "node":
+            cust_dict["node"][rec[-1]] = { "mask": rec[3], "protocol":rec[5], "type": rec[7] }
+        if rec[0] == "fcontext":
+            if rec[2] == "-e":
+                cust_dict["fcontext-equiv"][(rec[-1])] = { "equiv": rec[3] }
+            else:
+                cust_dict["fcontext"][(rec[-1],rec[3])] = { "type": rec[5] }
+        if rec[0] == "module":
+            cust_dict["module"][rec[-1]] = { "enabled": rec[2] != "-d" }
+        
+    return cust_dict
+if __name__ == "__main__": 
+    try:
+        dbus_proxy = SELinuxDBus()
+        resp = dbus_proxy.customized()
+        print convert_customization(resp)
+    except dbus.DBusException, e:
+        print e
diff --git a/policycoreutils/sepolicy/selinux_server.py b/policycoreutils/sepolicy/selinux_server.py
new file mode 100644
index 0000000..e5d3103
--- /dev/null
+++ b/policycoreutils/sepolicy/selinux_server.py
@@ -0,0 +1,131 @@
+#!/usr/bin/python
+
+import dbus
+import dbus.service
+import dbus.mainloop.glib
+import gobject
+import slip.dbus.service
+from slip.dbus import polkit
+import os
+import selinux
+from subprocess import Popen, PIPE, STDOUT
+
+class selinux_server(slip.dbus.service.Object):
+    default_polkit_auth_required = "org.selinux.semanage"
+    def __init__ (self, *p, **k):
+        super(selinux_server, self).__init__(*p, **k)
+
+    #
+    # The semanage method runs a transaction on a series of semanage commands,
+    # these commnds can take the output of customized
+    # 
+    @slip.dbus.polkit.require_auth("org.selinux.semanage")
+    @dbus.service.method("org.selinux", in_signature='s')
+    def semanage(self, buf):
+        p = Popen(["/usr/sbin/semanage", "import"],stdout=PIPE, stderr=PIPE, stdin=PIPE)
+        p.stdin.write(buf)
+        output = p.communicate()
+        if p.returncode and p.returncode != 0:
+            raise dbus.exceptions.DBusException(output[1])
+        
+    #
+    # The customized method will return all of the custommizations for policy
+    # on the server.  This output can be used with the semanage method on 
+    # another server to make the two systems have duplicate policy.
+    #
+    @slip.dbus.polkit.require_auth("org.selinux.customized")
+    @dbus.service.method("org.selinux", in_signature='', out_signature='s')
+    def customized(self):
+        p = Popen(["/usr/sbin/semanage", "export"],stdout=PIPE, stderr=PIPE)
+        buf = p.stdout.read()
+        output = p.communicate()
+        if p.returncode and p.returncode != 0:
+            raise OSError("Failed to read SELinux configuration: %s", output)
+        return buf
+        
+    #
+    # The semodule_list method will return the output of semodule -l, using the customized polkit,
+    # since this is a readonly behaviour
+    #
+    @slip.dbus.polkit.require_auth("org.selinux.customized")
+    @dbus.service.method("org.selinux", in_signature='', out_signature='s')
+    def semodule_list(self):
+        p = Popen(["/usr/sbin/semodule", "-l"],stdout=PIPE, stderr=PIPE)
+        buf = p.stdout.read()
+        output = p.communicate()
+        if p.returncode and p.returncode != 0:
+            raise OSError("Failed to list SELinux modules: %s", output)
+        return buf
+        
+    #
+    # The restorecon method modifies any file path to the default system label
+    #
+    @dbus.service.method("org.selinux", in_signature='s')
+    def restorecon(self, path):
+        selinux.restorecon(str(path), recursive=1)
+
+    #
+    # The setenforce method turns off the current enforcement of SELinux
+    #
+    @dbus.service.method("org.selinux", in_signature='i')
+    def setenforce(self, value):
+        selinux.security_setenforce(value)
+
+    #
+    # The setenforce method turns off the current enforcement of SELinux
+    #
+    @dbus.service.method("org.selinux", in_signature='i')
+    def relabel_on_boot(self, value):
+        if value == 1:
+            fd = open("/.autorelabel","w")
+            fd.close()
+        else:
+            os.unlink("/.autorelabel")
+
+    def write_selinux_config(self, enforcing=None, policy=None):
+        path = selinux.selinux_path() + "config" 
+        backup_path = path + ".bck"
+        fd = open(path)
+        lines = fd.readlines()
+        fd.close()
+        fd = open(backup_path, "w")
+        for l in lines:
+            if enforcing and l.startswith("SELINUX="):
+                fd.write("SELINUX=%s\n" % enforcing)
+                continue
+            if policy and l.startswith("SELINUXTYPE="):
+                fd.write("SELINUXTYPE=%s\n" % policy)
+                continue
+            fd.write(l)
+        fd.close()
+        os.rename(backup_path, path)
+
+    #
+    # The change_default_enforcement modifies the current enforcement mode 
+    #
+    @dbus.service.method("org.selinux", in_signature='s')
+    def change_default_mode(self, value):
+        values = [ "enforcing", "permissive", "disabled" ]
+        if value not in values:
+            raise ValueError("Enforcement mode must be %s" % ", ".join(values))
+        self.write_selinux_config(enforcing=value)
+        
+
+    #
+    # The change_default_policy method modifies the policy type
+    #
+    @dbus.service.method("org.selinux", in_signature='s')
+    def change_default_policy(self, value):
+        path = selinux.selinux_path() + value
+        if os.path.isdir(path):
+            return self.write_selinux_config(policy=value)
+        raise ValueError("%s does not exist" % path)
+        
+if __name__ == "__main__":
+        mainloop = gobject.MainLoop()
+        dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
+        system_bus = dbus.SystemBus()
+        name = dbus.service.BusName("org.selinux", system_bus)
+        object = selinux_server(system_bus, "/org/selinux/object")
+        slip.dbus.service.set_mainloop(mainloop)
+        mainloop.run()
diff --git a/policycoreutils/sepolicy/sepolicy-bash-completion.sh b/policycoreutils/sepolicy/sepolicy-bash-completion.sh
index 82fea52..779fd75 100644
--- a/policycoreutils/sepolicy/sepolicy-bash-completion.sh
+++ b/policycoreutils/sepolicy/sepolicy-bash-completion.sh
@@ -1,6 +1,6 @@
 # This file is part of systemd.
 #
-# Copyright 2012 Dan Walsh
+# Copyright 2012-2013 Dan Walsh
 #
 # systemd is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
@@ -69,6 +69,7 @@ _sepolicy () {
                [BOOLEANS]='booleans'
                [COMMUNICATE]='communicate'
                [GENERATE]='generate'
+               [GUI]='gui'
                [INTERFACE]='interface'
                [MANPAGE]='manpage'
                [NETWORK]='network'
@@ -80,8 +81,9 @@ _sepolicy () {
                [booleans]='-h --help -p --path -a -all -b --boolean'
                [communicate]='-h --help -s --source -t --target -c --class -S --sourceaccess -T --targetaccess'
                [generate]='-a --admin --admin_user --application --cgi --confined_admin --customize  -d --domain --dbus --desktop_user -h --help --inetd --init -n --name --newtype -p --path --sandbox -T --test --term_user -u --user -w --writepath --x_user'
-               [interface]='-h --help -a --list_admin" -u --list_user -l --list'
-               [manpage]='-h --help -p --path -a -all -o --os -d --domain -w --web'
+               [gui]='-h --help'
+               [interface]='-h --help -a --list_admin -c --compile -i --interface -l --list -u --list_user -u --list_user -v --verbose'
+               [manpage]='-h --help -p --path -a -all -o --os -d --domain -w --web -r --root'
                [network]='-h --help -d --domain -l --list -p --port -t --type '
                [transition]='-h --help -s --source -t --target'
         )
@@ -130,17 +132,17 @@ _sepolicy () {
                 COMPREPLY=( $( compgen -d -- "$cur") )
                 compopt -o filenames
                 return 0
-            elif [ "$prev" = "--type" -o "$prev" = "-t" ]; then
-                COMPREPLY=( $(compgen -W '0 1 2 3 4 5 6 7 8 9 10 11' -- "$cur") )
-                return 0
             elif [ "$prev" = "--domain" -o "$prev" = "-d" ]; then
                 COMPREPLY=( $(compgen -W "$( __get_all_domain_types ) " -- "$cur") )
                 return 0
+            elif [ "$prev" = "--newtype" ]; then
+                COMPREPLY=( $(compgen -W "-n --name -t --type" -- "$cur") )
+                return 0
             elif [ "$prev" = "--admin" -o "$prev" = "-a" ]; then
                 COMPREPLY=( $(compgen -W "$( __get_all_admin_interaces ) " -- "$cur") )
                 return 0
             elif [ "$prev" = "--user" -o "$prev" = "-u" ]; then
-                COMPREPLY=( $(compgen -W "$( __get_all_users ) " -- "$cur") )
+                COMPREPLY=( $(compgen -W "$( __get_all_users )" -- "$cur") )
                 return 0
             elif [[ "$cur" == "$verb" || "$cur" == "" || "$cur" == -* ]]; then
                 COMPREPLY=( $(compgen -W '${OPTS[$verb]}' -- "$cur") )
@@ -156,6 +158,10 @@ _sepolicy () {
             if [ "$prev" = "-d" -o "$prev" = "--domain" ]; then
                 COMPREPLY=( $(compgen -W "$( __get_all_domains ) " -- "$cur") )
                 return 0
+            elif test "$prev" = "-r" || test "$prev" = "--root" ; then
+                COMPREPLY=( $( compgen -d -- "$cur") )
+                compopt -o filenames
+                return 0
             elif [ "$prev" = "-o" -o "$prev" = "--os" ]; then
                 return 0
             elif test "$prev" = "-p" || test "$prev" = "--path" ; then
@@ -167,11 +173,11 @@ _sepolicy () {
             return 0
         elif [ "$verb" = "network" ]; then
             if [ "$prev" = "-t" -o "$prev" = "--type" ]; then
-                COMPREPLY=( $(compgen -W "$( __get_all_port_types ) " -- "$cur") )
+                COMPREPLY=( $(compgen -W "$( __get_all_port_types )" -- "$cur") )
                 return 0
             fi
             if [ "$prev" = "-d" -o "$prev" = "--domain" ]; then
-                COMPREPLY=( $(compgen -W "$( __get_all_domain_types ) " -- "$cur") )
+                COMPREPLY=( $(compgen -W "$( __get_all_domain_types )" -- "$cur") )
                 return 0
             fi
             COMPREPLY=( $(compgen -W '${OPTS[$verb]}' -- "$cur") )
diff --git a/policycoreutils/sepolicy/sepolicy.desktop b/policycoreutils/sepolicy/sepolicy.desktop
new file mode 100644
index 0000000..f9d0cec
--- /dev/null
+++ b/policycoreutils/sepolicy/sepolicy.desktop
@@ -0,0 +1,10 @@
+[Desktop Entry]
+Name=SELinux Policy Management Tool
+Comment=Generate SELinux policy modules
+Icon=system-config-selinux
+Exec=/usr/bin/sepolicy gui
+Type=Application
+Terminal=false
+Categories=System;Security;
+X-Desktop-File-Install-Version=0.2
+Keywords=policy;security;selinux;avc;permission;mac;
